// The Flock (a list of Boid objects)

class Flock {
  ArrayList<Boid> boids; // An ArrayList for all the boids

  Flock() {
    boids = new ArrayList<Boid>(); // Initialize the ArrayList
  }

  void run() {
    pushStyle();
    for (Boid b : boids) {
      b.run(boids);
      // Passing the entire list of boids to each boid individually
    }
    for (Boid b : boids) {
      b.update();
    }
    popStyle();
  }

  void addBoid(Boid b) {
    boids.add(b);
  }
  
  int count(int x0, int x1, int y0, int y1) {
    int n = 0;
    PVector A;
    for (Boid b : boids) {
      A = b.getLoc();
      if( A.x > x0 && A.x < x1 && A.y > y0 && A.y < y1 ) {
        n += 1;
      }
    }
    return n;
  }

}

